=== modified file 'INSTALL'
--- INSTALL	2008-07-10 18:40:16 +0000
+++ INSTALL	2008-07-12 07:25:25 +0000
@@ -2,7 +2,7 @@
 *************************
 
 Copyright (C) 1994, 1995, 1996, 1999, 2000, 2001, 2002, 2004, 2005,
-2006, 2007 Free Software Foundation, Inc.
+2006 Free Software Foundation, Inc.
 
 This file is free documentation; the Free Software Foundation gives
 unlimited permission to copy, distribute and modify it.
@@ -67,9 +67,6 @@
      all sorts of other programs in order to regenerate files that came
      with the distribution.
 
-  6. Often, you can also type `make uninstall' to remove the installed
-     files again.
-
 Compilers and Options
 =====================
 

=== modified file 'include/mysql/plugin.h'
--- include/mysql/plugin.h	2008-07-09 15:52:52 +0000
+++ include/mysql/plugin.h	2008-07-12 07:25:25 +0000
@@ -427,6 +427,24 @@
 
 
 /*************************************************************************
+  API for UDF plugin. (MYSQL_UDF_PLUGIN)
+*/
+
+/* handlertons of different MySQL releases are incompatible */
+#define MYSQL_UDF_INTERFACE_VERSION (MYSQL_VERSION_ID << 8)
+
+/*
+  Here we define only the descriptor structure, that is referred from
+  st_mysql_plugin.
+*/
+
+struct st_mysql_udf
+{
+  int interface_version;
+};
+
+
+/*************************************************************************
   API for I_S plugin. (MYSQL_INFORMATION_SCHEMA_PLUGIN)
 */
 

=== modified file 'plugin/Makefile.am'
--- plugin/Makefile.am	2008-07-01 21:55:08 +0000
+++ plugin/Makefile.am	2008-07-12 07:25:25 +0000
@@ -22,4 +22,4 @@
 #EXTRA_DIST =	fulltext/configure.in	
 
 SUBDIRS =	@mysql_pg_dirs@
-DIST_SUBDIRS =	
+DIST_SUBDIRS =	hello_world

=== modified file 'server/Makefile.am'
--- server/Makefile.am	2008-07-11 10:33:22 +0000
+++ server/Makefile.am	2008-07-12 07:25:25 +0000
@@ -22,7 +22,8 @@
 pkgplugindir =		$(pkglibdir)/plugin
 AM_CPPFLAGS =		-I$(top_builddir)/include -I$(top_srcdir)/include \
 			-I$(srcdir) $(openssl_includes) \
-			$(libevent_includes)
+			$(libevent_includes) \
+			-ggdb
 SUBDIRS =		share
 libexec_PROGRAMS =	drizzled
 EXTRA_PROGRAMS =	gen_lex_hash

=== modified file 'server/drizzled.cc'
--- server/drizzled.cc	2008-07-11 15:49:04 +0000
+++ server/drizzled.cc	2008-07-12 07:25:25 +0000
@@ -2738,8 +2738,6 @@
     exit(1);
   }
 
-  udf_init();
-
   init_status_vars();
   if (opt_bootstrap) /* If running with bootstrap, do not start replication. */
     opt_skip_slave_start= 1;

=== modified file 'server/item_func.cc'
--- server/item_func.cc	2008-07-09 22:08:01 +0000
+++ server/item_func.cc	2008-07-12 07:25:25 +0000
@@ -2749,8 +2749,6 @@
 ** Rewritten by monty.
 ****************************************************************************/
 
-#ifdef HAVE_DLOPEN
-
 void udf_handler::cleanup()
 {
   if (!not_original)
@@ -2762,7 +2760,7 @@
         Udf_func_deinit deinit= u_d->func_deinit;
         (*deinit)(&initid);
       }
-      free_udf(u_d);
+
       initialized= false;
     }
     if (buffers)				// Because of bug in ecc
@@ -2802,7 +2800,6 @@
 	  sql_alloc(f_args.arg_count*sizeof(Item_result))))
 
     {
-      free_udf(u_d);
       return(true);
     }
     uint i;
@@ -2849,7 +2846,6 @@
 	!(f_args.attribute_lengths= (ulong*) sql_alloc(arg_count *
 						       sizeof(long))))
     {
-      free_udf(u_d);
       return(true);
     }
   }
@@ -2918,7 +2914,6 @@
     {
       my_error(ER_CANT_INITIALIZE_UDF, MYF(0),
                u_d->name.str, init_msg_buff);
-      free_udf(u_d);
       return(true);
     }
     func->max_length=min(initid.max_length,MAX_BLOB_WIDTH);
@@ -3195,10 +3190,6 @@
   assert(not_original || !(initialized || buffers));
 }
 
-#else
-bool udf_handler::get_arguments() { return 0; }
-#endif /* HAVE_DLOPEN */
-
 /*
 ** User level locks
 */

=== modified file 'server/sql_plugin.cc'
--- server/sql_plugin.cc	2008-07-11 16:06:20 +0000
+++ server/sql_plugin.cc	2008-07-12 07:25:25 +0000
@@ -44,6 +44,9 @@
 extern int initialize_schema_table(st_plugin_int *plugin);
 extern int finalize_schema_table(st_plugin_int *plugin);
 
+extern int initialize_udf(st_plugin_int *plugin);
+extern int finalize_udf(st_plugin_int *plugin);
+
 /*
   The number of elements in both plugin_type_initialize and
   plugin_type_deinitialize should equal to the number of plugins
@@ -51,31 +54,29 @@
 */
 plugin_type_init plugin_type_initialize[MYSQL_MAX_PLUGIN_TYPE_NUM]=
 {
-  0,ha_initialize_handlerton,0,0,initialize_schema_table,
+  initialize_udf,ha_initialize_handlerton,0,0,initialize_schema_table,
   0
 };
 
 plugin_type_init plugin_type_deinitialize[MYSQL_MAX_PLUGIN_TYPE_NUM]=
 {
-  0,ha_finalize_handlerton,0,0,finalize_schema_table,
+  finalize_udf,ha_finalize_handlerton,0,0,finalize_schema_table,
   0
 };
 
-#ifdef HAVE_DLOPEN
 static const char *plugin_interface_version_sym=
                    "_mysql_plugin_interface_version_";
 static const char *sizeof_st_plugin_sym=
                    "_mysql_sizeof_struct_st_plugin_";
 static const char *plugin_declarations_sym= "_mysql_plugin_declarations_";
 static int min_plugin_interface_version= MYSQL_PLUGIN_INTERFACE_VERSION & ~0xFF;
-#endif
 
 /* Note that 'int version' must be the first field of every plugin
    sub-structure (plugin->info).
 */
 static int min_plugin_info_interface_version[MYSQL_MAX_PLUGIN_TYPE_NUM]=
 {
-  0x0000,
+  MYSQL_UDF_INTERFACE_VERSION,
   MYSQL_HANDLERTON_INTERFACE_VERSION,
   MYSQL_FTPARSER_INTERFACE_VERSION,
   MYSQL_DAEMON_INTERFACE_VERSION,
@@ -84,7 +85,7 @@
 };
 static int cur_plugin_info_interface_version[MYSQL_MAX_PLUGIN_TYPE_NUM]=
 {
-  0x0000, /* UDF: not implemented */
+  MYSQL_UDF_INTERFACE_VERSION,
   MYSQL_HANDLERTON_INTERFACE_VERSION,
   MYSQL_FTPARSER_INTERFACE_VERSION,
   MYSQL_DAEMON_INTERFACE_VERSION,
@@ -267,8 +268,6 @@
   Plugin support code
 ****************************************************************************/
 
-#ifdef HAVE_DLOPEN
-
 static struct st_plugin_dl *plugin_dl_find(const LEX_STRING *dl)
 {
   uint i;
@@ -285,7 +284,6 @@
   return(0);
 }
 
-
 static st_plugin_dl *plugin_dl_insert_or_reuse(struct st_plugin_dl *plugin_dl)
 {
   uint i;
@@ -307,15 +305,11 @@
                                            sizeof(struct st_plugin_dl));
   return(tmp);
 }
-#endif /* HAVE_DLOPEN */
-
 
 static inline void free_plugin_mem(struct st_plugin_dl *p)
 {
-#ifdef HAVE_DLOPEN
   if (p->handle)
     dlclose(p->handle);
-#endif
   my_free(p->dl.str, MYF(MY_ALLOW_ZERO_PTR));
   if (p->version != MYSQL_PLUGIN_INTERFACE_VERSION)
     my_free((uchar*)p->plugins, MYF(MY_ALLOW_ZERO_PTR));

=== modified file 'server/sql_udf.cc'
--- server/sql_udf.cc	2008-07-09 16:33:52 +0000
+++ server/sql_udf.cc	2008-07-12 07:25:25 +0000
@@ -18,13 +18,6 @@
 /*
    Known bugs:
   
-   Memory for functions is never freed!
-   Shared libraries are not closed before mysqld exits;
-     - This is because we can't be sure if some threads are using
-       a function.
-  
-   The bugs only affect applications that create and free a lot of
-   dynamic functions, so this shouldn't be a real problem.
 */
 
 #ifdef USE_PRAGMA_IMPLEMENTATION
@@ -34,451 +27,121 @@
 #include "mysql_priv.h"
 #include <my_pthread.h>
 
-#ifdef HAVE_DLOPEN
 extern "C"
 {
 #include <stdarg.h>
 #include <hash.h>
 }
 
-static bool initialized = 0;
+static bool udf_startup= false; /* We do not lock because startup is single threaded */
 static MEM_ROOT mem;
 static HASH udf_hash;
-static rw_lock_t THR_LOCK_udf;
-
 
 static udf_func *add_udf(LEX_STRING *name, Item_result ret,
                          char *dl, Item_udftype typ);
 static void del_udf(udf_func *udf);
-static void *find_udf_dl(const char *dl);
-
-static char *init_syms(udf_func *tmp, char *nm)
-{
-  char *end;
-
-  if (!((tmp->func= (Udf_func_any) dlsym(tmp->dlhandle, tmp->name.str))))
-    return tmp->name.str;
-
-  end=strmov(nm,tmp->name.str);
-
-  if (tmp->type == UDFTYPE_AGGREGATE)
-  {
-    (void)strmov(end, "_clear");
-    if (!((tmp->func_clear= (Udf_func_clear) dlsym(tmp->dlhandle, nm))))
-      return nm;
-    (void)strmov(end, "_add");
-    if (!((tmp->func_add= (Udf_func_add) dlsym(tmp->dlhandle, nm))))
-      return nm;
-  }
-
-  (void) strmov(end,"_deinit");
-  tmp->func_deinit= (Udf_func_deinit) dlsym(tmp->dlhandle, nm);
-
-  (void) strmov(end,"_init");
-  tmp->func_init= (Udf_func_init) dlsym(tmp->dlhandle, nm);
-
-  /*
-    to prefent loading "udf" from, e.g. libc.so
-    let's ensure that at least one auxiliary symbol is defined
-  */
-  if (!tmp->func_init && !tmp->func_deinit && tmp->type != UDFTYPE_AGGREGATE)
-    return nm;
-  return 0;
-}
-
 
 extern "C" uchar* get_hash_key(const uchar *buff, size_t *length,
 			      my_bool not_used __attribute__((unused)))
 {
-  udf_func *udf=(udf_func*) buff;
-  *length=(uint) udf->name.length;
+  udf_func *udf= (udf_func*) buff;
+  *length= (uint) udf->name.length;
   return (uchar*) udf->name.str;
 }
 
 
-/*
-  Read all predeclared functions from mysql.func and accept all that
-  can be used.
-*/
-
 void udf_init()
 {
-  TABLE_LIST tables;
-
-  if (initialized)
-    return;
-
-  my_rwlock_init(&THR_LOCK_udf,NULL);
-
   init_sql_alloc(&mem, UDF_ALLOC_BLOCK_SIZE, 0);
-  THD *new_thd = new THD;
-  if (!new_thd ||
-      hash_init(&udf_hash,system_charset_info,32,0,0,get_hash_key, NULL, 0))
+
+  if (hash_init(&udf_hash, system_charset_info, 32, 0, 0, get_hash_key, NULL, 0))
   {
     sql_print_error("Can't allocate memory for udf structures");
     hash_free(&udf_hash);
-    free_root(&mem,MYF(0));
-    delete new_thd;
+    free_root(&mem, MYF(0));
     return;
   }
-
-  initialized = 1;
-  close_thread_tables(new_thd);
-  delete new_thd;
-  /* Remember that we don't have a THD */
-  my_pthread_setspecific_ptr(THR_THD,  0);
-  return;
 }
 
-
+/* called by mysqld.cc clean_up() */
 void udf_free()
 {
-  /* close all shared libraries */
-  
-  for (uint idx=0 ; idx < udf_hash.records ; idx++)
-  {
-    udf_func *udf=(udf_func*) hash_element(&udf_hash,idx);
-    if (udf->dlhandle)				// Not closed before
-    {
-      /* Mark all versions using the same handler as closed */
-      for (uint j=idx+1 ;  j < udf_hash.records ; j++)
-      {
-	udf_func *tmp=(udf_func*) hash_element(&udf_hash,j);
-	if (udf->dlhandle == tmp->dlhandle)
-	  tmp->dlhandle=0;			// Already closed
-      }
-      dlclose(udf->dlhandle);
-    }
-  }
   hash_free(&udf_hash);
-  free_root(&mem,MYF(0));
-  if (initialized)
-  {
-    initialized= 0;
-    rwlock_destroy(&THR_LOCK_udf);
-  }
-  return;
-}
-
-
-static void del_udf(udf_func *udf)
-{
-  
-  if (!--udf->usage_count)
-  {
-    hash_delete(&udf_hash,(uchar*) udf);
-    using_udf_functions=udf_hash.records != 0;
-  }
-  else
-  {
-    /*
-      The functions is in use ; Rename the functions instead of removing it.
-      The functions will be automaticly removed when the least threads
-      doesn't use it anymore
-    */
-    char *name= udf->name.str;
-    uint name_length=udf->name.length;
-    udf->name.str=(char*) "*";
-    udf->name.length=1;
-    hash_update(&udf_hash,(uchar*) udf,(uchar*) name,name_length);
-  }
-  return;
-}
-
-
-void free_udf(udf_func *udf)
-{
-  
-  
-  if (!initialized)
-    return;
-
-  rw_wrlock(&THR_LOCK_udf);
-  if (!--udf->usage_count)
-  {
-    /*
-      We come here when someone has deleted the udf function
-      while another thread still was using the udf
-    */
-    hash_delete(&udf_hash,(uchar*) udf);
-    using_udf_functions=udf_hash.records != 0;
-    if (!find_udf_dl(udf->dl))
-      dlclose(udf->dlhandle);
-  }
-  rw_unlock(&THR_LOCK_udf);
-  return;
-}
-
+  free_root(&mem, MYF(0));
+}
 
 /* This is only called if using_udf_functions != 0 */
-
-udf_func *find_udf(const char *name,uint length,bool mark_used)
-{
-  udf_func *udf=0;
-  
-
-  if (!initialized)
-    return(NULL);
-
-  /* TODO: This should be changed to reader locks someday! */
-  if (mark_used)
-    rw_wrlock(&THR_LOCK_udf);  /* Called during fix_fields */
-  else
-    rw_rdlock(&THR_LOCK_udf);  /* Called during parsing */
-
-  if ((udf=(udf_func*) hash_search(&udf_hash,(uchar*) name,
-				   length ? length : (uint) strlen(name))))
-  {
-    if (!udf->dlhandle)
-      udf=0;					// Could not be opened
-    else if (mark_used)
-      udf->usage_count++;
-  }
-  rw_unlock(&THR_LOCK_udf);
-  return(udf);
-}
-
-
-static void *find_udf_dl(const char *dl)
-{
-  
-
-  /*
-    Because only the function name is hashed, we have to search trough
-    all rows to find the dl.
-  */
-  for (uint idx=0 ; idx < udf_hash.records ; idx++)
-  {
-    udf_func *udf=(udf_func*) hash_element(&udf_hash,idx);
-    if (!strcmp(dl, udf->dl) && udf->dlhandle != NULL)
-      return(udf->dlhandle);
-  }
-  return(0);
-}
-
-
-/* Assume that name && dl is already allocated */
-
-static udf_func *add_udf(LEX_STRING *name, Item_result ret, char *dl,
-			 Item_udftype type)
-{
-  if (!name || !dl || !(uint) type || (uint) type > (uint) UDFTYPE_AGGREGATE)
-    return 0;
-  udf_func *tmp= (udf_func*) alloc_root(&mem, sizeof(udf_func));
-  if (!tmp)
-    return 0;
-  bzero((char*) tmp,sizeof(*tmp));
-  tmp->name = *name; //dup !!
-  tmp->dl = dl;
-  tmp->returns = ret;
-  tmp->type = type;
-  tmp->usage_count=1;
-  if (my_hash_insert(&udf_hash,(uchar*)  tmp))
-    return 0;
-  using_udf_functions=1;
-  return tmp;
-}
-
-
-/**
-  Create a user defined function. 
-
-  @note Like implementations of other DDL/DML in MySQL, this function
-  relies on the caller to close the thread tables. This is done in the
-  end of dispatch_command().
-*/
-
-int mysql_create_function(THD *thd,udf_func *udf)
-{
-  int error;
-  void *dl=0;
-  bool new_dl=0;
-  TABLE *table;
-  TABLE_LIST tables;
-  udf_func *u_d;
-  
-
-  if (!initialized)
-  {
-    if (opt_noacl)
-      my_error(ER_CANT_INITIALIZE_UDF, MYF(0),
-               udf->name.str,
-               "UDFs are unavailable with the --skip-grant-tables option");
-    else
-      my_message(ER_OUT_OF_RESOURCES, ER(ER_OUT_OF_RESOURCES), MYF(0));
-    return(1);
-  }
-
-  /*
-    Ensure that the .dll doesn't have a path
-    This is done to ensure that only approved dll from the system
-    directories are used (to make this even remotely secure).
-
-    On windows we must check both FN_LIBCHAR and '/'.
-  */
-  if (my_strchr(files_charset_info, udf->dl,
-                udf->dl + strlen(udf->dl), FN_LIBCHAR) ||
-      IF_WIN(my_strchr(files_charset_info, udf->dl,
-                       udf->dl + strlen(udf->dl), '/'), 0))
-  {
-    my_message(ER_UDF_NO_PATHS, ER(ER_UDF_NO_PATHS), MYF(0));
-    return(1);
-  }
-  if (check_identifier_name(&udf->name, ER_TOO_LONG_IDENT))
-    return(1);
-
-  /* 
-    Turn off row binlogging of this statement and use statement-based 
-    so that all supporting tables are updated for CREATE FUNCTION command.
-  */
-  if (thd->current_stmt_binlog_row_based)
-    thd->clear_current_stmt_binlog_row_based();
-
-  rw_wrlock(&THR_LOCK_udf);
-  if ((hash_search(&udf_hash,(uchar*) udf->name.str, udf->name.length)))
-  {
-    my_error(ER_UDF_EXISTS, MYF(0), udf->name.str);
-    goto err;
-  }
-  if (!(dl = find_udf_dl(udf->dl)))
-  {
-    char dlpath[FN_REFLEN];
-    strxnmov(dlpath, sizeof(dlpath) - 1, opt_plugin_dir, "/", udf->dl, NullS);
-    if (!(dl = dlopen(dlpath, RTLD_NOW)))
-    {
-      my_error(ER_CANT_OPEN_LIBRARY, MYF(0),
-               udf->dl, errno, dlerror());
-      goto err;
-    }
-    new_dl=1;
-  }
-  udf->dlhandle=dl;
-  {
-    char buf[NAME_LEN+16], *missing;
-    if ((missing= init_syms(udf, buf)))
-    {
-      my_error(ER_CANT_FIND_DL_ENTRY, MYF(0), missing);
-      goto err;
-    }
-  }
-  udf->name.str=strdup_root(&mem,udf->name.str);
-  udf->dl=strdup_root(&mem,udf->dl);
-  if (!(u_d=add_udf(&udf->name,udf->returns,udf->dl,udf->type)))
-    goto err;
-  u_d->dlhandle = dl;
-  u_d->func=udf->func;
-  u_d->func_init=udf->func_init;
-  u_d->func_deinit=udf->func_deinit;
-  u_d->func_clear=udf->func_clear;
-  u_d->func_add=udf->func_add;
-
-  /* create entry in mysql.func table */
-
-  bzero((char*) &tables,sizeof(tables));
-  tables.db= (char*) "mysql";
-  tables.table_name= tables.alias= (char*) "func";
-  /* Allow creation of functions even if we can't open func table */
-  if (!(table = open_ltable(thd, &tables, TL_WRITE, 0)))
-    goto err;
-  table->use_all_columns();
-  restore_record(table, s->default_values);	// Default values for fields
-  table->field[0]->store(u_d->name.str, u_d->name.length, system_charset_info);
-  table->field[1]->store((longlong) u_d->returns, TRUE);
-  table->field[2]->store(u_d->dl,(uint) strlen(u_d->dl), system_charset_info);
-  if (table->s->fields >= 4)			// If not old func format
-    table->field[3]->store((longlong) u_d->type, TRUE);
-  error = table->file->ha_write_row(table->record[0]);
-
-  if (error)
-  {
-    my_error(ER_ERROR_ON_WRITE, MYF(0), "mysql.func", error);
-    del_udf(u_d);
-    goto err;
-  }
-  rw_unlock(&THR_LOCK_udf);
-
-  /* Binlog the create function. */
-  write_bin_log(thd, TRUE, thd->query, thd->query_length);
-
-  return(0);
-
- err:
-  if (new_dl)
-    dlclose(dl);
-  rw_unlock(&THR_LOCK_udf);
-  return(1);
-}
-
-
-int mysql_drop_function(THD *thd,const LEX_STRING *udf_name)
-{
-  TABLE *table;
-  TABLE_LIST tables;
+udf_func *find_udf(const char *name, uint length, bool mark_used)
+{
   udf_func *udf;
-  char *exact_name_str;
-  uint exact_name_len;
+
+  if (udf_startup == false)
+    return NULL;
+
+  udf= (udf_func*) hash_search(&udf_hash,
+                               (uchar*) name,
+                               length ? length : (uint) strlen(name));
+
+  return (udf);
+}
+
+static bool add_udf(udf_func *udf)
+{
+  if (my_hash_insert(&udf_hash, (uchar*) udf))
+    return false;
+
+  using_udf_functions= 1;
+
+  return true;
+}
+
+int initialize_udf(st_plugin_int *plugin)
+{
+  udf_func *udff;
+
+  if (udf_startup == false)
+  {
+    udf_init();
+    udf_startup= true;
+  }
+	  
+  /* allocate the udf_func structure */
+  udff = (udf_func *)my_malloc(sizeof(udf_func), MYF(MY_WME | MY_ZEROFILL));
+  if (udff == NULL) return 1;
+
+  plugin->data= (void *)udff;
+
+  if (plugin->plugin->init)
+  {
+    /* todo, if the plugin doesnt have an init, bail out */
+
+    if (plugin->plugin->init((void *)udff))
+    {
+      sql_print_error("Plugin '%s' init function returned error.",
+                      plugin->name.str);
+      goto err;
+    }
+  }
   
-
-  if (!initialized)
-  {
-    if (opt_noacl)
-      my_error(ER_FUNCTION_NOT_DEFINED, MYF(0), udf_name->str);
-    else
-      my_message(ER_OUT_OF_RESOURCES, ER(ER_OUT_OF_RESOURCES), MYF(0));
-    return(1);
-  }
-
-  /* 
-    Turn off row binlogging of this statement and use statement-based
-    so that all supporting tables are updated for DROP FUNCTION command.
-  */
-  if (thd->current_stmt_binlog_row_based)
-    thd->clear_current_stmt_binlog_row_based();
-
-  rw_wrlock(&THR_LOCK_udf);  
-  if (!(udf=(udf_func*) hash_search(&udf_hash,(uchar*) udf_name->str,
-				    (uint) udf_name->length)))
-  {
-    my_error(ER_FUNCTION_NOT_DEFINED, MYF(0), udf_name->str);
-    goto err;
-  }
-  exact_name_str= udf->name.str;
-  exact_name_len= udf->name.length;
-  del_udf(udf);
-  /*
-    Close the handle if this was function that was found during boot or
-    CREATE FUNCTION and it's not in use by any other udf function
-  */
-  if (udf->dlhandle && !find_udf_dl(udf->dl))
-    dlclose(udf->dlhandle);
-
-  bzero((char*) &tables,sizeof(tables));
-  tables.db=(char*) "mysql";
-  tables.table_name= tables.alias= (char*) "func";
-  if (!(table = open_ltable(thd, &tables, TL_WRITE, 0)))
-    goto err;
-  table->use_all_columns();
-  table->field[0]->store(exact_name_str, exact_name_len, &my_charset_bin);
-  if (!table->file->index_read_idx_map(table->record[0], 0,
-                                       (uchar*) table->field[0]->ptr,
-                                       HA_WHOLE_KEY,
-                                       HA_READ_KEY_EXACT))
-  {
-    int error;
-    if ((error = table->file->ha_delete_row(table->record[0])))
-      table->file->print_error(error, MYF(0));
-  }
-  close_thread_tables(thd);
-
-  rw_unlock(&THR_LOCK_udf);
-
-  /* Binlog the drop function. */
-  write_bin_log(thd, TRUE, thd->query, thd->query_length);
-
-  return(0);
- err:
-  rw_unlock(&THR_LOCK_udf);
-  return(1);
-}
-
-#endif /* HAVE_DLOPEN */
+  add_udf(udff);
+
+  return 0;
+err:
+  my_free(udff, MYF(0));
+  return 1;
+}
+
+int finalize_udf(st_plugin_int *plugin)
+{ 
+  udf_func *udff = (udf_func *)plugin->data;
+
+  /* TODO: Issue warning on failure */
+  if (udff && plugin->plugin->deinit)
+    (void)plugin->plugin->deinit(udff);
+
+  if (udff)
+    my_free(udff, MYF(0));
+
+  return 0;
+}
+

=== modified file 'server/sql_udf.h'
--- server/sql_udf.h	2008-07-07 14:25:25 +0000
+++ server/sql_udf.h	2008-07-12 07:25:25 +0000
@@ -36,14 +36,12 @@
   LEX_STRING name;
   Item_result returns;
   Item_udftype type;
-  char *dl;
-  void *dlhandle;
   Udf_func_any func;
   Udf_func_init func_init;
   Udf_func_deinit func_deinit;
   Udf_func_clear func_clear;
   Udf_func_add func_add;
-  ulong usage_count;
+  void *data;
 } udf_func;
 
 class Item_result_field;
@@ -133,10 +131,7 @@
 };
 
 
-#ifdef HAVE_DLOPEN
 void udf_init(void),udf_free(void);
 udf_func *find_udf(const char *name, uint len=0,bool mark_used=0);
 void free_udf(udf_func *udf);
 int mysql_create_function(THD *thd,udf_func *udf);
-int mysql_drop_function(THD *thd,const LEX_STRING *name);
-#endif

=== modified file 'server/sql_yacc.yy'
--- server/sql_yacc.yy	2008-07-10 21:15:26 +0000
+++ server/sql_yacc.yy	2008-07-12 07:25:25 +0000
@@ -3797,7 +3797,6 @@
 function_call_generic:
           IDENT_sys '('
           {
-#ifdef HAVE_DLOPEN
             udf_func *udf= 0;
             LEX *lex= Lex;
             if (using_udf_functions &&
@@ -3812,7 +3811,6 @@
             }
             /* Temporary placing the result of find_udf in $3 */
             $<udf>$= udf;
-#endif
           }
           opt_udf_expr_list ')'
           {
@@ -3836,10 +3834,9 @@
             }
             else
             {
-#ifdef HAVE_DLOPEN
               /* Retrieving the result of find_udf */
               udf_func *udf= $<udf>3;
-
+              if (udf)
               {
                 if (udf->type == UDFTYPE_AGGREGATE)
                 {
@@ -3848,7 +3845,6 @@
 
                 item= Create_udf_func::s_singleton.create(thd, udf, $4);
               }
-#endif
             }
 
             if (! ($$= item))

